# tencent_tpns_oppo_push_plugin

集成腾讯tpns OPPO推送，兼容OPPO原生推送。

## Getting Started



- 初始化

```dart
TencentTpnsOppoPushPlugin.init(needLog: true);
```

- 设置回调

```dart
callback(data) {
    
    Map<String, dynamic> m = new Map();
    print(data['name']);//onRegister onUnRegister onSetPushTime onGetPushStatus onGetNotificationStatus
    print(data['responseCode']); //参照OPPO原生推送错误码，https://open.oppomobile.com/wiki/doc#id=10704
    print(data['data']);//返回的数据
    
  }
TencentTpnsOppoPushPlugin.setCallback(callback: callback);
```

- 检测设备是否支持

```dart
bool isSupport = await TencentTpnsOppoPushPlugin.isSupportPush();
```

- 注册推送服务

```dart
TencentTpnsOppoPushPlugin.register(
      appKey: "$appKey",
      appSecret: "$appSecret",
);
```

### 其他方法

1. getRegister 获取注册OPPO PUSH推送服务的注册ID
2. setAppKeySecret 设置appKey等参数,可以覆盖register中的appkey设置
3. unRegister 解注册OPPO PUSH推送服务
4. pausePush 暂停接收OPPO PUSH服务推送的消息
5. resumePush 恢复接收OPPO PUSH服务推送的消息，这时服务器会把暂停时期的推送消息重新推送过来
6. getPushStatus 获取OPPO PUSH推送服务状态
7. getSDKVersion 获取OPPO PUSH推送服务SDK版本（例如”2.1.0”）
8. getPushVersionCode 获取OPPO PUSH推送服务MCS版本(例如“2.4.0”)
9. getPushVersionName 获取OPPO PUSH推送服务MCS名称(例如“2400”)
10. setPushTime 设置允许推送时间 API
11. requestNotificationPermission 弹出通知栏权限弹窗（仅一次）
12. openNotificationSetting 打开通知栏设置界面
13. getNotificationStatus 获取通知栏状态，从callback回调结果